import { computed as V, ref as c, watch as A, withDirectives as H, createElementBlock as p, openBlock as f, createElementVNode as C, createCommentVNode as U, normalizeStyle as b, createVNode as P, Fragment as T, renderList as j, unref as G, onMounted as ne, nextTick as le, onBeforeUnmount as re, normalizeClass as D, vModelText as ae, withModifiers as q } from "vue";
import { G as se, l as ue, X as ce } from "./index-CgWFTIG9.js";
import L from "./BaseIcon-DCvCVV6b.js";
import { v as ie } from "./usePrinter-DVQLRjmi.js";
import { _ as J } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const de = { style: { height: "100%", width: "100%", position: "relative" } }, ve = { class: "icon" }, pe = ["onClick"], fe = { style: { position: "absolute", top: "50%", left: "50%", transform: "translate(-50%, -46%)" } }, ke = ["value"], he = {
  __name: "ColorPicker",
  props: {
    value: {
      type: String,
      default: "#ffffff"
    },
    size: {
      type: String,
      default: "50px"
    },
    backgroundColor: {
      type: String,
      default: "#FFFFFF"
    },
    buttonBorderColor: {
      type: String,
      default: "#FFFFFF"
    }
  },
  emits: ["update:value"],
  setup(r, { emit: E }) {
    const k = r, R = E, h = V(() => ({
      backgroundColor: k.value,
      width: "100%",
      height: "100%",
      cursor: "pointer"
    })), y = c(null), $ = c(!1), M = () => {
      var u;
      (u = y.value) == null || u.click();
    };
    function S(u) {
      R("update:value", u), $.value = !1;
    }
    function x() {
      $.value = !1;
    }
    function N() {
      $.value && x();
    }
    const X = (u) => {
      const B = u.target.value;
      R("update:value", B);
    }, F = V(() => se(k.value));
    A(
      () => k.value,
      (u) => {
        y.value.value = u;
      }
    );
    const w = c([
      "#000000",
      "#FFFFFF",
      "#FF5733",
      "#33FF57",
      "#3357FF",
      "#FFC300",
      "#800080",
      "#FF1493",
      "#00CED1"
    ]);
    return (u, B) => H((f(), p("div", de, [
      C("div", {
        onClick: B[0] || (B[0] = (z) => $.value = !$.value),
        style: b(h.value)
      }, [
        C("div", ve, [
          P(L, {
            name: "palette",
            stroke: F.value,
            size: 22
          }, null, 8, ["stroke"])
        ])
      ], 4),
      $.value ? (f(), p("div", {
        key: 0,
        class: "vue-ui-color-picker",
        style: b({
          backgroundColor: r.backgroundColor
        })
      }, [
        (f(!0), p(T, null, j(w.value, (z) => (f(), p("div", {
          class: "vue-ui-color-picker-option",
          style: b({
            backgroundColor: z,
            outline: `1px solid ${r.buttonBorderColor}`
          }),
          onClick: () => S(z)
        }, null, 12, pe))), 256)),
        C("div", {
          class: "vue-ui-color-picker-option",
          onClick: M,
          style: b({
            backgroundColor: r.value,
            outline: `1px solid ${r.buttonBorderColor}`
          })
        }, [
          C("div", fe, [
            P(L, {
              name: "colorPicker",
              stroke: F.value,
              size: 22
            }, null, 8, ["stroke"])
          ]),
          C("input", {
            ref_key: "colorInput",
            ref: y,
            type: "color",
            value: r.value,
            class: "hidden-input",
            onInput: X
          }, null, 40, ke)
        ], 4)
      ], 4)) : U("", !0)
    ])), [
      [G(ie), N]
    ]);
  }
}, ge = /* @__PURE__ */ J(he, [["__scopeId", "data-v-84e6c062"]]), me = {
  class: /* @__PURE__ */ D({
    "vue-ui-pen-and-paper-action": !0
  }),
  style: { padding: "0 !important" }
}, Ce = ["disabled"], ye = ["xmlns", "viewBox"], $e = ["cx", "cy", "r", "fill"], be = ["d", "stroke", "stroke-width"], Fe = ["d", "stroke", "stroke-width"], xe = {
  __name: "PenAndPaper",
  props: {
    parent: {
      type: HTMLElement
    },
    backgroundColor: {
      type: String,
      default: "#FFFFFF"
    },
    color: {
      type: String,
      default: "#2D353C"
    },
    active: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["close"],
  setup(r, { emit: E }) {
    const k = r, R = E, h = c([]), y = c([]), $ = c("0 0 0 0"), M = c(k.color), S = c(1), x = V(() => ue(k.color, 0.6));
    function N({ width: o, height: t }) {
      $.value = `0 0 ${o} ${t}`;
    }
    const X = c(null);
    ne(() => {
      le(() => {
        if (k.parent) {
          X.value = new ResizeObserver((e) => {
            for (const n of e) {
              const { width: l, height: a } = n.contentRect;
              N({ width: l, height: a });
            }
          }), X.value.observe(k.parent);
          const { width: o, height: t } = k.parent.getBoundingClientRect();
          N({ width: o, height: t });
        }
      });
    }), re(() => {
      X.value && X.value.disconnect();
    }), A(
      () => k.parent,
      (o) => {
        if (!o) return;
        const { width: t, height: e } = k.parent.getBoundingClientRect();
        N({ width: t, height: e });
      },
      { immediate: !0 }
    );
    const F = c(!1), w = c(""), u = c(null);
    function B(o) {
      if (!u.value) return;
      F.value = !0;
      const { x: t, y: e } = Q(o);
      w.value = `M ${t} ${e}`;
    }
    function z(o) {
      if (!F.value || !u.value) return;
      const { x: t, y: e } = Q(o);
      w.value += ` ${t} ${e}`;
    }
    function W(o) {
      const t = o.trim().split(/\s+/);
      if (t.length < 4)
        return o;
      const e = t.slice(1).map(Number);
      if (e.length % 2 !== 0)
        return o;
      const n = K(e), l = [`M ${n[0]} ${n[1]}`];
      for (let i = 2; i < n.length - 2; i += 2) {
        const g = n[i - 2], m = n[i - 1], d = n[i], v = n[i + 1], Y = (g + d) / 2, I = (m + v) / 2;
        l.push(`Q ${g} ${m} ${Y} ${I}`);
      }
      const a = n[n.length - 2], s = n[n.length - 1];
      return l.push(`L ${a} ${s}`), l.join(" ");
    }
    function K(o, t = 1) {
      const e = [...o];
      for (let n = 2; n < o.length - 2; n += 2) {
        const l = o[n], a = o[n + 1], s = o[n - 2], i = o[n - 1], g = o[n + 2], m = o[n + 3];
        e[n] = l + t * ((s + g) / 2 - l), e[n + 1] = a + t * ((i + m) / 2 - a);
      }
      return e;
    }
    function Z(o) {
      const t = o.trim().split(/\s+/);
      let e = "", n = "", l = null, a = null;
      for (let s = 0; s < t.length; s += 1) {
        const i = t[s];
        if (isNaN(i)) {
          if (n = i, n === "M" || n === "L")
            l = parseFloat(t[++s]), a = parseFloat(t[++s]), e += `${n}${l} ${a}`;
          else if (n === "Q") {
            const g = parseFloat(t[++s]), m = parseFloat(t[++s]), d = parseFloat(t[++s]), v = parseFloat(t[++s]);
            g === l && m === a ? e += `t${d - l} ${v - a}` : e += `q${g - l} ${m - a} ${d - l} ${v - a}`, l = d, a = v;
          }
        } else {
          const g = parseFloat(i), m = parseFloat(t[++s]);
          if (n === "L") {
            const d = g - l, v = m - a;
            d === 0 ? e += `v${v}` : v === 0 ? e += `h${d}` : e += `l${d} ${v}`, l = g, a = m;
          } else if (n === "Q") {
            const d = g, v = m, Y = parseFloat(t[++s]), I = parseFloat(t[++s]);
            d === l && v === a ? e += `t${Y - l} ${I - a}` : e += `q${d - l} ${v - a} ${Y - l} ${I - a}`, l = Y, a = I;
          }
        }
      }
      return e;
    }
    function O() {
      F.value && (h.value.push({
        strokeWidth: S.value,
        path: Z(W(w.value)),
        color: M.value
      }), y.value = [], w.value = ""), F.value = !1;
    }
    function Q(o) {
      if (!u.value) return { x: 0, y: 0 };
      const t = u.value.getBoundingClientRect();
      let e, n;
      return o.touches && o.touches.length ? (e = o.touches[0].clientX, n = o.touches[0].clientY) : (e = o.clientX, n = o.clientY), {
        x: e - t.left,
        y: n - t.top
      };
    }
    c(!1);
    function _() {
      if (h.value.length > 0) {
        const o = h.value.pop();
        y.value.push(o);
      }
    }
    function ee() {
      if (y.value.length > 0) {
        const o = y.value.pop();
        h.value.push(o);
      }
    }
    function te() {
      h.value = [], y.value = [];
    }
    const oe = c(null);
    return (o, t) => (f(), p(T, null, [
      r.active ? (f(), p("div", {
        key: 0,
        "data-html2canvas-ignore": "",
        class: D({
          "vue-ui-pen-and-paper-actions": !0,
          visible: r.active
        })
      }, [
        C("button", {
          class: "vue-ui-pen-and-paper-action",
          style: b({
            backgroundColor: r.backgroundColor,
            border: `1px solid ${x.value}`
          }),
          onClick: t[0] || (t[0] = (e) => R("close"))
        }, [
          P(L, {
            name: "close",
            stroke: r.color
          }, null, 8, ["stroke"])
        ], 4),
        C("button", me, [
          P(ge, {
            value: M.value,
            "onUpdate:value": t[1] || (t[1] = (e) => M.value = e),
            backgroundColor: r.backgroundColor,
            buttonBorderColor: x.value
          }, null, 8, ["value", "backgroundColor", "buttonBorderColor"])
        ]),
        C("button", {
          class: D({
            "vue-ui-pen-and-paper-action": !0,
            "vue-ui-pen-and-paper-action-disabled": !h.value.length
          }),
          disabled: !h.value.length,
          style: b({
            backgroundColor: r.backgroundColor,
            border: `1px solid ${x.value}`
          }),
          onClick: _
        }, [
          P(L, {
            name: "restart",
            stroke: r.color
          }, null, 8, ["stroke"])
        ], 14, Ce),
        C("button", {
          class: D({
            "vue-ui-pen-and-paper-action": !0,
            "vue-ui-pen-and-paper-action-disabled": !y.value.length
          }),
          style: b({
            backgroundColor: r.backgroundColor,
            border: `1px solid ${x.value}`
          }),
          onClick: ee
        }, [
          P(L, {
            name: "restart",
            stroke: r.color,
            style: { transform: "scaleX(-1)" }
          }, null, 8, ["stroke"])
        ], 6),
        C("button", {
          class: D([{
            "vue-ui-pen-and-paper-action": !0,
            "vue-ui-pen-and-paper-action-disabled": !h.value.length
          }, "vue-ui-pen-and-paper-action"]),
          style: b({
            backgroundColor: r.backgroundColor,
            border: `1px solid ${x.value}`
          }),
          onClick: te
        }, [
          P(L, {
            name: "trash",
            stroke: r.color
          }, null, 8, ["stroke"])
        ], 6),
        H(C("input", {
          ref_key: "range",
          ref: oe,
          type: "range",
          class: "vertical-range",
          min: 0.5,
          max: 12,
          step: 0.1,
          "onUpdate:modelValue": t[2] || (t[2] = (e) => S.value = e),
          style: b({
            accentColor: r.color
          })
        }, null, 4), [
          [ae, S.value]
        ])
      ], 2)) : U("", !0),
      (f(), p("svg", {
        ref_key: "svgElement",
        ref: u,
        xmlns: G(ce),
        viewBox: $.value,
        class: D({
          "vue-ui-pen-and-paper": !0,
          inactive: !r.active
        }),
        onMousedown: B,
        onMousemove: z,
        onMouseup: O,
        onMouseleave: O,
        onTouchstart: q(B, ["prevent"]),
        onTouchmove: q(z, ["prevent"]),
        onTouchend: O
      }, [
        (f(!0), p(T, null, j(h.value, (e) => (f(), p(T, { key: e }, [
          e.path.replace("M", "").split(" ").length === 2 ? (f(), p("circle", {
            key: 0,
            cx: e.path.replace("M", "").split(" ")[0],
            cy: e.path.replace("M", "").split(" ")[1],
            r: e.strokeWidth / 2,
            fill: e.color
          }, null, 8, $e)) : (f(), p("path", {
            key: 1,
            class: "vue-ui-pen-and-paper-path",
            d: e.path,
            stroke: e.color,
            "stroke-width": e.strokeWidth,
            fill: "none"
          }, null, 8, be))
        ], 64))), 128)),
        F.value ? (f(), p("path", {
          key: 0,
          class: "vue-ui-pen-and-paper-path vue-ui-pen-and-paper-path-drawing",
          d: W(w.value),
          stroke: M.value,
          "stroke-width": S.value * 1.1,
          fill: "none"
        }, null, 8, Fe)) : U("", !0)
      ], 42, ye))
    ], 64));
  }
}, Xe = /* @__PURE__ */ J(xe, [["__scopeId", "data-v-a932b1ac"]]);
export {
  Xe as P
};
