import { ref as h, useSlots as W, onMounted as R, computed as x, watch as H, createElementBlock as a, openBlock as o, normalizeStyle as i, createCommentVNode as y, createElementVNode as r, toDisplayString as g, unref as s, Fragment as P, renderList as q, withKeys as J } from "vue";
import { u as Q, c as Z, o as tt, e as et, i as $, f as b, X as k, w as F, W as X } from "./index-CgWFTIG9.js";
import { u as lt } from "./useNestedProp-DSDe8aSH.js";
import { _ as at } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const ot = {
  key: 0,
  class: "vue-ui-rating-title",
  style: { width: "100%" }
}, it = ["src", "height", "width"], st = ["xmlns", "height", "width"], nt = ["id"], rt = ["stop-color"], ut = ["stop-color"], vt = ["points", "fill", "stroke", "stroke-width"], dt = ["src", "alt", "height", "width", "id"], yt = ["xmlns", "viewBox", "height", "id"], pt = ["id"], gt = ["stop-color"], ct = ["stop-color"], ft = ["points", "fill", "stroke"], mt = ["xmlns", "height"], ht = ["onClick", "onMouseenter", "onKeyup"], xt = ["onMouseenter"], $t = {
  __name: "vue-ui-rating",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  emits: ["rate"],
  setup(j, { expose: B, emit: I }) {
    const { vue_ui_rating: Y } = Q(), u = j, m = h(Z()), z = h(!1), d = h(void 0), _ = h([]), G = W();
    R(() => {
      G["chart-background"] && console.warn("VueUiRating does not support the #chart-background slot.");
    });
    const L = I, t = x({
      get: () => C(),
      set: (l) => l
    });
    function C() {
      return lt({
        userConfig: u.config,
        defaultConfig: Y
      });
    }
    H(() => u.config, (l) => {
      t.value = C(), M();
    }, { deep: !0 });
    const O = x(() => typeof u.dataset.rating == "object" && !Array.isArray(u.dataset.rating) ? D(u.dataset.rating) : u.dataset.rating), U = x(() => typeof u.dataset.rating == "object" && !Array.isArray(u.dataset.rating)), v = h(O.value), S = x(() => t.value.type === "image"), c = x(() => t.value.readonly);
    function D(l) {
      let n = 0, e = 0;
      for (const p in l) {
        const T = parseInt(p), A = l[p];
        n += T * A, e += A;
      }
      if (e === 0)
        return 0;
      const f = n / e;
      return Math.min(t.value.to, Math.max(t.value.from, f));
    }
    R(() => {
      M();
    });
    function M() {
      tt(u.dataset) && et({
        componentName: "VueUiRating",
        type: "dataset"
      }), _.value = [];
      for (let l = t.value.from; l <= t.value.to; l += 1)
        _.value.push(l);
    }
    function w(l, n = !1) {
      return l > d.value || c.value ? n ? t.value.style.image.inactiveOpacity : t.value.style.star.inactiveColor : n ? 1 : t.value.style.star.useGradient ? `url(#star_gradient_under_${m.value})` : t.value.style.star.activeColor;
    }
    function N(l, n = !1) {
      const e = v.value - l, f = n ? 1 : 100;
      switch (!0) {
        case e <= 0:
          return 1e-3;
        case e > 1:
          return 1 * f;
        default:
          return e * f;
      }
    }
    function V(l) {
      c.value || (v.value = l, L("rate", l));
    }
    function E() {
      return v.value;
    }
    function K(l = !0) {
      c.value = l;
    }
    return B({
      getData: E,
      toggleReadonly: K
    }), (l, n) => (o(), a("div", {
      style: i(`background:${t.value.style.backgroundColor};font-family:${t.value.style.fontFamily};width:100%`),
      class: "vue-ui-rating",
      onMouseover: n[2] || (n[2] = (e) => z.value = !0),
      onMouseleave: n[3] || (n[3] = (e) => {
        z.value = !1, d.value = void 0;
      })
    }, [
      t.value.style.title.text ? (o(), a("div", ot, [
        r("div", {
          style: i(`color:${t.value.style.title.color};font-weight:${t.value.style.title.bold ? "bold" : "normal"};text-align:${t.value.style.title.textAlign};margin-bottom:${t.value.style.title.offsetY}px;font-size:${t.value.style.title.fontSize}px`)
        }, g(t.value.style.title.text), 5),
        t.value.style.title.subtitle.text ? (o(), a("div", {
          key: 0,
          style: i(`color:${t.value.style.title.subtitle.color};font-size:${t.value.style.title.subtitle.fontSize}px;text-align:${t.value.style.title.textAlign};margin-bottom:${t.value.style.title.subtitle.offsetY}px;font-weight:${t.value.style.title.subtitle.bold ? "bold" : "normal"}`)
        }, g(t.value.style.title.subtitle.text), 5)) : y("", !0)
      ])) : y("", !0),
      t.value.style.rating.show && t.value.style.rating.position === "top" ? (o(), a("div", {
        key: 1,
        style: i(`width:100%;text-align:center;margin-bottom:${t.value.style.rating.offsetY}px;font-size:${t.value.style.rating.fontSize}px;font-weight:${t.value.style.rating.bold ? "bold" : "normal"};margin-left:${t.value.style.rating.offsetX}px`)
      }, g(s($)(
        t.value.style.rating.formatter,
        v.value,
        s(b)({
          v: v.value,
          r: t.value.style.rating.roundingValue
        }),
        t.value
      )), 5)) : y("", !0),
      r("div", {
        class: "vue-ui-rating-wrapper",
        style: i(`height:${t.value.style.itemSize}px;width:100%;display:flex;align-items:center;justify-content:center`)
      }, [
        t.value.style.rating.show && t.value.style.rating.position === "left" ? (o(), a("div", {
          key: 0,
          style: i(`width:fit-content;text-align:center;margin-bottom:${t.value.style.rating.offsetY}px;font-size:${t.value.style.rating.fontSize}px;font-weight:${t.value.style.rating.bold ? "bold" : "normal"};padding-right:${t.value.style.rating.offsetX}px`)
        }, g(s($)(
          t.value.style.rating.formatter,
          v.value,
          s(b)({
            v: v.value,
            r: t.value.style.rating.roundingValue
          }),
          t.value
        )), 5)) : y("", !0),
        (o(!0), a(P, null, q(_.value, (e, f) => (o(), a("div", {
          class: "vue-ui-rating-unit-container",
          style: i(`position:relative;height:${t.value.style.itemSize}px;width:${t.value.style.itemSize}px`)
        }, [
          S.value ? (o(), a("img", {
            key: 0,
            src: t.value.style.image.src,
            height: t.value.style.itemSize,
            width: t.value.style.itemSize,
            class: "vue-ui-rating-unit",
            style: i(`position:absolute;top:0;left:0;opacity:${isNaN(d.value) ? t.value.style.image.inactiveOpacity : w(e, !0)}`)
          }, null, 12, it)) : (o(), a("svg", {
            key: 1,
            xmlns: s(k),
            viewBox: "0 0 100 100",
            height: t.value.style.itemSize,
            width: t.value.style.itemSize,
            class: "vue-ui-rating-unit"
          }, [
            r("defs", null, [
              r("radialGradient", {
                cx: "50%",
                cy: "50%",
                r: "50%",
                fx: "50%",
                fy: "50%",
                id: `star_gradient_under_${m.value}`
              }, [
                r("stop", {
                  offset: "0%",
                  "stop-color": `${s(F)(t.value.style.star.activeColor, 0.05)}`
                }, null, 8, rt),
                r("stop", {
                  offset: "100%",
                  "stop-color": t.value.style.star.activeColor
                }, null, 8, ut)
              ], 8, nt)
            ]),
            r("polygon", {
              points: s(X)({
                plot: { x: 50, y: 50 },
                radius: 30,
                apexes: t.value.style.star.apexes
              }),
              fill: isNaN(d.value) ? t.value.style.star.inactiveColor : w(e),
              stroke: t.value.style.star.borderColor ? t.value.style.star.borderColor : d.value ? w(e) : t.value.style.star.inactiveColor,
              "stroke-width": t.value.style.star.borderWidth,
              "stroke-linecap": "round",
              "stroke-linejoin": "round"
            }, null, 8, vt)
          ], 8, st)),
          S.value ? (o(), a("img", {
            key: 2,
            src: t.value.style.image.src,
            alt: `${t.value.style.image.alt} ${e}`,
            height: t.value.style.itemSize,
            width: t.value.style.itemSize,
            id: `active_${m.value}_${e}`,
            class: "vue-ui-rating-unit",
            style: i(`position:absolute;top:0;left:0;clip:rect(0px,${N(f, !0) * t.value.style.itemSize}px,${t.value.style.itemSize}px,0px`)
          }, null, 12, dt)) : (o(), a("svg", {
            key: 3,
            xmlns: s(k),
            viewBox: `0 0 ${N(f)} 100`,
            height: t.value.style.itemSize,
            class: "vue-ui-rating-unit",
            id: `active_${m.value}_${e}`,
            style: { position: "absolute", top: "0", left: "0" }
          }, [
            r("defs", null, [
              r("radialGradient", {
                cx: "50%",
                cy: "50%",
                r: "50%",
                fx: "50%",
                fy: "50%",
                id: `star_gradient_over_${m.value}`
              }, [
                r("stop", {
                  offset: "0%",
                  "stop-color": `${s(F)(t.value.style.star.activeColor, 0.05)}`
                }, null, 8, gt),
                r("stop", {
                  offset: "100%",
                  "stop-color": t.value.style.star.activeColor
                }, null, 8, ct)
              ], 8, pt)
            ]),
            r("polygon", {
              points: s(X)({
                plot: { x: 50, y: 50 },
                radius: 30,
                apexes: t.value.style.star.apexes
              }),
              fill: t.value.style.star.useGradient ? `url(#star_gradient_over_${m.value})` : t.value.style.star.activeColor,
              stroke: t.value.style.star.activeColor
            }, null, 8, ft)
          ], 8, yt)),
          (o(), a("svg", {
            xmlns: s(k),
            viewBox: "0 0 100 100",
            height: t.value.style.itemSize,
            class: "vue-ui-rating-unit",
            style: i(`position:absolute;top:0;left:0;${c.value ? "" : "cursor:pointer"}`)
          }, [
            c.value ? y("", !0) : (o(), a("rect", {
              key: 0,
              class: "vue-ui-rating-mouse-trap",
              x: 0,
              y: 0,
              width: 100,
              height: 100,
              fill: "transparent",
              onClick: (p) => V(e),
              onMouseenter: (p) => d.value = e,
              onMouseleave: n[0] || (n[0] = (p) => d.value = void 0),
              tabindex: "0",
              onKeyup: J((p) => V(e), ["enter"])
            }, null, 40, ht)),
            c.value ? (o(), a("rect", {
              key: 1,
              class: "vue-ui-rating-mouse-trap",
              x: 0,
              y: 0,
              width: 100,
              height: 100,
              fill: "transparent",
              onMouseenter: (p) => d.value = e,
              onMouseleave: n[1] || (n[1] = (p) => d.value = void 0)
            }, null, 40, xt)) : y("", !0)
          ], 12, mt)),
          t.value.style.tooltip.show && U.value && c.value ? (o(), a("div", {
            key: 4,
            class: "vue-ui-rating-tooltip",
            style: i(`border:1px solid ${t.value.style.tooltip.borderColor};position:absolute;top:${-48 + t.value.style.tooltip.offsetY}px;left:50%;transform:translateX(-50%);width:fit-content;text-align:center;background:${t.value.style.tooltip.backgroundColor};display:${d.value === e ? "block" : "none"};padding:2px 12px;border-radius:${t.value.style.tooltip.borderRadius}px;box-shadow:${t.value.style.tooltip.boxShadow}`)
          }, [
            r("div", {
              style: i(`width:100%;display:flex;flex-direction:row;gap:6px;position:relative;text-align:center;color:${t.value.style.tooltip.color}`)
            }, [
              r("span", {
                style: i(`font-size:${t.value.style.tooltip.fontSize}px`)
              }, g(e) + ":", 5),
              r("span", {
                style: i(`font-weight:${t.value.style.tooltip.bold ? "bold" : "normal"};font-size:${t.value.style.tooltip.fontSize}px`)
              }, g(s($)(
                t.value.style.tooltip.formatter,
                u.dataset.rating[e],
                s(b)({
                  v: u.dataset.rating[e],
                  r: t.value.style.tooltip.roundingValue
                }),
                t.value
              )), 5),
              r("div", {
                style: i(`font-family:Arial !important;position:absolute;top:calc(100% - 4px);left:50%;transform:translateX(-50%);color:${t.value.style.tooltip.borderColor}`)
              }, " ▼ ", 4)
            ], 4)
          ], 4)) : y("", !0)
        ], 4))), 256)),
        t.value.style.rating.show && t.value.style.rating.position === "right" ? (o(), a("div", {
          key: 1,
          style: i(`width:fit-content;text-align:center;margin-bottom:${t.value.style.rating.offsetY}px;font-size:${t.value.style.rating.fontSize}px;font-weight:${t.value.style.rating.bold ? "bold" : "normal"};padding-left:${t.value.style.rating.offsetX}px`)
        }, g(s($)(
          t.value.style.rating.formatter,
          v.value,
          s(b)({
            v: v.value,
            r: t.value.style.rating.roundingValue
          }),
          t.value
        )), 5)) : y("", !0)
      ], 4),
      t.value.style.rating.show && t.value.style.rating.position === "bottom" ? (o(), a("div", {
        key: 2,
        style: i(`width:100%;text-align:center;margin-top:${t.value.style.rating.offsetY}px;font-size:${t.value.style.rating.fontSize}px;font-weight:${t.value.style.rating.bold ? "bold" : "normal"};margin-left:${t.value.style.rating.offsetX}px`)
      }, g(s($)(
        t.value.style.rating.formatter,
        v.value,
        s(b)({
          v: v.value,
          r: t.value.style.rating.roundingValue
        }),
        t.value
      )), 5)) : y("", !0)
    ], 36));
  }
}, zt = /* @__PURE__ */ at($t, [["__scopeId", "data-v-9e1d13d5"]]);
export {
  zt as default
};
