import { ref as v, computed as m, useSlots as Ma, onMounted as ea, watch as H, nextTick as ce, onBeforeUnmount as Oa, createElementBlock as K, openBlock as w, unref as z, normalizeClass as Pa, normalizeStyle as Y, createCommentVNode as _, createBlock as E, createElementVNode as Q, createSlots as Ra, withCtx as p, renderSlot as b, normalizeProps as V, guardReactiveProps as Z, createVNode as Fa, toDisplayString as aa, createTextVNode as Ea } from "vue";
import { u as Da, c as Aa, t as Na, p as U, a as Ha, C as de, b as _a, D as Ce, i as ee, f as ae, d as la, _ as Ua, J as Wa, a9 as Xa, o as Ba, e as Ya, x as ta, q as Va, r as Za, y as Ga, s as le, l as ja } from "./index-CgWFTIG9.js";
import { d as qa, t as Ja, u as Ka, c as Qa, a as oa, l as x, r as we, b as D, p as ra } from "./useResponsive-CoxXLe23.js";
import { _ as el } from "./Tooltip-Dvk5hWuz.js";
import { L as al } from "./Legend-Cro1p_Hw.js";
import { _ as ll } from "./Title-DlRsN8Ie.js";
import { S as tl } from "./Slicer-Qfhzf4PS.js";
import { u as ol, U as rl } from "./usePrinter-DVQLRjmi.js";
import ul from "./vue-ui-accordion-Cms_Ab9s.js";
import { D as sl } from "./DataTable-DTuvAsnZ.js";
import nl from "./vue-ui-skeleton-CvolcGVP.js";
import { u as ua } from "./useNestedProp-DSDe8aSH.js";
import { P as il } from "./PenAndPaper-7DCNMpkg.js";
import { u as vl } from "./useUserOptionState-BIvW1Kz7.js";
import { _ as cl } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const dl = ["id"], hl = ["onClick"], yl = {
  key: 2,
  class: "vue-data-ui-watermark"
}, fl = ["innerHTML"], gl = {
  __name: "vue-ui-xy-canvas",
  props: {
    dataset: {
      type: Array,
      default() {
        return [];
      }
    },
    config: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  emits: ["selectLegend"],
  setup(ze, { expose: sa, emit: na }) {
    const { vue_ui_xy_canvas: ia } = Da(), f = ze, he = v(Aa()), G = v(null), I = v(null), j = v(null), n = v(null), y = v(1), P = v(1), te = v(!1), d = v(null), oe = v(""), Se = v(null), S = v([]), W = v(1), A = v(!0), T = v(!0), ye = v(null), $e = v(0), Ie = v(0), re = v(!1), Te = v(null), Me = v(null), Oe = v(null), Pe = v(null), fe = v(0), ge = v(0), pe = v(0), me = m(() => !!f.dataset && f.dataset.length), va = na, ca = Ma();
    ea(() => {
      ca["chart-background"] && console.warn("VueUiXyCanvas does not support the #chart-background slot.");
    });
    const a = m({
      get: () => Ee(),
      set: (e) => e
    }), { userOptionsVisible: be, setUserOptionsVisibility: Re, keepUserOptionState: Fe } = vl({ config: a.value });
    function Ee() {
      const e = ua({
        userConfig: f.config,
        defaultConfig: ia
      });
      let l = {};
      return e.theme ? l = {
        ...ua({
          userConfig: Ha.vue_ui_xy_canvas[e.theme] || f.config,
          defaultConfig: e
        }),
        customPalette: Na[e.theme] || U
      } : l = e, f.config && de(f.config, "style.chart.scale.min") ? l.style.chart.scale.min = f.config.style.chart.scale.min : l.style.chart.scale.min = null, f.config && de(f.config, "style.chart.scale.max") ? l.style.chart.scale.max = f.config.style.chart.scale.max : l.style.chart.scale.max = null, f.config && de(f.config, "style.chart.zoom.startIndex") ? l.style.chart.zoom.startIndex = f.config.style.chart.zoom.startIndex : l.style.chart.zoom.startIndex = null, f.config && de(f.config, "style.chart.zoom.endIndex") ? l.style.chart.zoom.endIndex = f.config.style.chart.zoom.endIndex : l.style.chart.zoom.endIndex = null, l;
    }
    H(() => f.config, (e) => {
      a.value = Ee(), be.value = !a.value.userOptions.showOnChartHover, Le(), fe.value += 1, ge.value += 1, pe.value += 1, u.value.showTable = a.value.table.show, u.value.showDataLabels = a.value.style.chart.dataLabels.show, u.value.stacked = a.value.style.chart.stacked, u.value.showTooltip = a.value.style.chart.tooltip.show;
    }, { deep: !0 }), H(() => f.dataset, () => {
      Le(), fe.value += 1, ge.value += 1, pe.value += 1;
    }, { deep: !0 });
    const De = v(a.value.style.chart.aspectRatio), { isPrinting: Ae, isImaging: Ne, generatePdf: He, generateImage: _e } = ol({
      elementId: `xy_canvas_${he.value}`,
      fileName: a.value.style.chart.title.text || "vue-ui-xy-canvas"
    }), u = v({
      showTable: a.value.table.show,
      showDataLabels: a.value.style.chart.dataLabels.show,
      stacked: a.value.style.chart.stacked,
      showTooltip: a.value.style.chart.tooltip.show
    });
    function da(e) {
      re.value = e, Ie.value += 1;
    }
    const Ue = m(() => _a(a.value.customPalette)), $ = m(() => X.value ? Math.max(...X.value.filter((e, l) => !S.value.includes(e.absoluteIndex)).map((e) => e.series.length)) : 0), t = m(() => {
      const e = y.value - y.value * (a.value.style.chart.paddingProportions.left + a.value.style.chart.paddingProportions.right);
      return {
        canvasWidth: y.value,
        canvasHeight: P.value,
        left: y.value * a.value.style.chart.paddingProportions.left,
        top: P.value * a.value.style.chart.paddingProportions.top,
        right: y.value - y.value * a.value.style.chart.paddingProportions.right,
        bottom: P.value - P.value * a.value.style.chart.paddingProportions.bottom,
        width: e,
        height: P.value - P.value * (a.value.style.chart.paddingProportions.top + a.value.style.chart.paddingProportions.bottom),
        slot: e / (r.value.end - r.value.start)
      };
    });
    function We(e, l) {
      return e / l;
    }
    function ha({ hasAutoScale: e, series: l, min: o, max: c, scale: i, yOffset: k, individualHeight: s, stackIndex: C = null }) {
      return l.map((M, R) => {
        const F = i.min < 0 ? Math.abs(i.min) : 0, N = We(M + F, F + i.max);
        let q, J;
        e && (q = Math.abs(i.min), J = We(M + q, i.max + q));
        let O = 0;
        return C === null ? O = t.value.bottom - t.value.height * (e ? J : N) : O = t.value.bottom - k - s * (e ? J : N), {
          x: t.value.left + t.value.slot * R + t.value.slot / 2,
          y: O,
          value: M
        };
      });
    }
    const g = m(() => {
      const e = a.value.style.chart.scale.min !== null ? a.value.style.chart.scale.min : Math.min(...X.value.filter((s, C) => !S.value.includes(s.absoluteIndex)).flatMap((s) => s.series.slice(r.value.start, r.value.end))), l = a.value.style.chart.scale.max !== null ? a.value.style.chart.scale.max : Math.max(...X.value.filter((s, C) => !S.value.includes(s.absoluteIndex)).flatMap((s) => s.series.slice(r.value.start, r.value.end))), o = Ce(e < 0 ? e : 0, l === e ? e + 1 < 0 ? 0 : e + 1 : l < 0 ? 0 : l, a.value.style.chart.scale.ticks), c = o.min < 0 ? Math.abs(o.min) : 0, i = t.value.bottom - t.value.height * (c / (o.max + c)), k = o.ticks.map((s) => ({
        y: t.value.bottom - t.value.height * ((s + c) / (o.max + c)),
        x: t.value.left - 8,
        value: s
      }));
      return {
        absoluteMin: c,
        max: l,
        min: e,
        scale: o,
        yLabels: k,
        zero: i
      };
    }), ya = m(() => h.value.map((e) => `
            <div style="display:flex;flex-direction:row;gap:6px;align-items:center;">
                <svg viewBox="0 0 10 10" height="12" width="12">
                    <circle cx="5" cy="5" r="5" fill="${e.color}"/>
                </svg>
                <span>${e.name ? e.name + ": " : ""}</span>
                <span>${ee(
      a.value.style.chart.dataLabels.formatter,
      e.series[d.value],
      ae({
        p: e.prefix || "",
        v: e.series[d.value],
        s: e.suffix || "",
        r: e.rounding || 0
      }),
      { datapoint: e, seriesIndex: d.value }
    )}</span>
            </div>
        `)), X = m(() => f.dataset.map((e, l) => ({
      ...e,
      series: Ua({
        data: Wa(e.series),
        threshold: a.value.downsample.threshold
      }),
      absoluteIndex: l,
      color: la(e.color || Ue.value[l] || U[l] || U[l % U.length])
    })));
    H($, (e) => {
      e && Xe();
    });
    const h = m(() => Xa(X.value.filter((e, l) => !S.value.includes(e.absoluteIndex))).map((e, l) => ({
      ...e,
      series: e.series.slice(r.value.start, r.value.end)
    })).map((e, l) => {
      let o = [null, void 0].includes(e.scaleMin) ? Math.min(...e.series) || 0 : e.scaleMin, c = [null, void 0].includes(e.scaleMax) ? Math.max(...e.series) || 1 : e.scaleMax;
      o === c && (o = o >= 0 ? c - 1 : o, c = c >= 0 ? c : o + 1), e.series.filter((O) => ![null, void 0].includes(O)).map((O) => (O - o) / (c - o));
      const i = {
        valueMin: o,
        valueMax: c
      }, k = e.scaleSteps || a.value.style.chart.scale.ticks;
      let s;
      e.autoScaling ? s = Ce(i.valueMin, i.valueMax, k) : s = Ce(i.valueMin < 0 ? i.valueMin : 0, i.valueMax <= 0 ? 0 : i.valueMax, k);
      const C = u.value.stacked ? t.value.height * (1 - e.cumulatedStackRatio) : 0, M = u.value.stacked ? t.value.height / a.value.style.chart.stackGap : 0, R = u.value.stacked ? t.value.height * e.stackRatio - M : t.value.height, F = s.min < 0 ? Math.abs(s.min) : 0;
      let N;
      e.autoScaling && u.value.stacked && c <= 0 ? N = t.value.bottom - C - R : N = t.value.bottom - C - R * (F / (s.max + F));
      const q = s.ticks.map((O, Ta) => ({
        y: t.value.bottom - C - R * (Ta / (s.ticks.length - 1)),
        x: t.value.left - 8,
        value: O
      })), J = ha({
        hasAutoScale: u.value.stacked && e.autoScaling,
        series: e.series,
        min: u.value.stacked ? o : g.value.min,
        max: u.value.stacked ? c : g.value.max,
        scale: u.value.stacked ? s : g.value.scale,
        yOffset: C,
        individualHeight: R,
        stackIndex: u.value.stacked ? l : null
      });
      return {
        ...e,
        coordinatesLine: J,
        min: o,
        max: c,
        localScale: s,
        localZero: N,
        localMin: F,
        localYLabels: q,
        yOffset: C,
        individualHeight: R
      };
    })), r = v({
      start: 0,
      end: $.value
    });
    function Xe() {
      Be();
    }
    const B = v(null);
    async function Be() {
      (a.value.style.chart.zoom.startIndex !== null || a.value.style.chart.zoom.endIndex !== null) && B.value ? (a.value.style.chart.zoom.startIndex !== null && (await ce(), await ce(), B.value && B.value.setStartValue(a.value.style.chart.zoom.startIndex)), a.value.style.chart.zoom.endIndex !== null && (await ce(), await ce(), B.value && B.value.setEndValue(fa(a.value.style.chart.zoom.endIndex + 1)))) : (r.value = {
        start: 0,
        end: $.value
      }, $e.value += 1);
    }
    function fa(e) {
      const l = $.value;
      return e > l ? l : e < 0 || a.value.style.chart.zoom.startIndex !== null && e < a.value.style.chart.zoom.startIndex ? a.value.style.chart.zoom.startIndex !== null ? a.value.style.chart.zoom.startIndex + 1 : 1 : e;
    }
    const ga = m(() => h.value.filter((e) => ["line", "plot", void 0].includes(e.type))), L = m(() => h.value.filter((e) => e.type === "bar"));
    function pa() {
      if (!I.value)
        return;
      const e = j.value.offsetWidth, l = j.value.offsetHeight;
      I.value.width = e * W.value * 2, I.value.height = l * W.value * 2, y.value = e * W.value * 2, P.value = l * W.value * 2, n.value.scale(W.value, W.value), xe();
    }
    function ma() {
      if (n.value.clearRect(0, 0, 1e4, 1e4), n.value.fillStyle = a.value.style.chart.backgroundColor, n.value.fillRect(0, 0, t.value.canvasWidth, t.value.canvasHeight), u.value.stacked)
        a.value.style.chart.grid.y.verticalLines.show && r.value.end - r.value.start < a.value.style.chart.grid.y.verticalLines.hideUnderXLength ? h.value.forEach((e) => {
          for (let l = 0; l < r.value.end - r.value.start + 1; l += 1)
            x(
              n.value,
              [
                {
                  x: t.value.left + t.value.slot * l,
                  y: t.value.bottom - e.yOffset - e.individualHeight
                },
                {
                  x: t.value.left + t.value.slot * l,
                  y: t.value.bottom - e.yOffset
                }
              ],
              {
                color: a.value.style.chart.grid.y.verticalLines.color
              }
            );
        }) : a.value.style.chart.grid.y.verticalLines.show && r.value.end - r.value.start >= a.value.style.chart.grid.y.verticalLines.hideUnderXLength && h.value.forEach((e) => {
          for (let l = r.value.start; l < r.value.end; l += 1)
            l % Math.floor((r.value.end - r.value.start) / a.value.style.chart.grid.y.timeLabels.modulo) === 0 && x(
              n.value,
              [
                {
                  x: t.value.left + t.value.slot * (l - r.value.start) + t.value.slot / 2,
                  y: t.value.bottom - e.yOffset - e.individualHeight
                },
                {
                  x: t.value.left + t.value.slot * (l - r.value.start) + t.value.slot / 2,
                  y: t.value.bottom - e.yOffset
                }
              ],
              {
                color: a.value.style.chart.grid.y.verticalLines.color
              }
            );
        }), a.value.style.chart.grid.x.horizontalLines.show && (a.value.style.chart.grid.x.horizontalLines.alternate ? h.value.forEach((e) => {
          e.localYLabels.forEach((l, o) => {
            o < e.localYLabels.length - 1 && we(
              n.value,
              [
                { x: t.value.left, y: l.y },
                { x: t.value.right, y: l.y },
                { x: t.value.right, y: e.localYLabels[o + 1].y },
                { x: t.value.left, y: e.localYLabels[o + 1].y }
              ],
              {
                fillColor: o % 2 === 0 ? "transparent" : le(a.value.style.chart.grid.x.horizontalLines.color, a.value.style.chart.grid.x.horizontalLines.opacity),
                strokeColor: "transparent"
              }
            );
          });
        }) : h.value.forEach((e) => {
          e.localYLabels.slice(r.value.start, r.value.end).forEach((l) => {
            x(
              n.value,
              [
                { x: t.value.left, y: l.y },
                { x: t.value.right, y: l.y }
              ],
              {
                color: a.value.style.chart.grid.x.horizontalLines.color
              }
            );
          });
        })), a.value.style.chart.grid.zeroLine.show && h.value.forEach((e) => {
          x(
            n.value,
            [
              { x: t.value.left, y: e.localZero },
              { x: t.value.right, y: e.localZero }
            ],
            {
              color: a.value.style.chart.grid.zeroLine.color,
              lineDash: a.value.style.chart.grid.zeroLine.dashed ? [10, 10] : [0, 0]
            }
          );
        }), a.value.style.chart.grid.y.axisLabels.show && h.value.forEach((e) => {
          x(
            n.value,
            [
              { x: t.value.left, y: t.value.bottom - e.yOffset },
              { x: t.value.left, y: t.value.bottom - e.yOffset - e.individualHeight }
            ],
            {
              color: e.color
            }
          ), x(
            n.value,
            [
              { x: t.value.right, y: t.value.bottom - e.yOffset },
              { x: t.value.right, y: t.value.bottom - e.yOffset - e.individualHeight }
            ],
            {
              color: e.color
            }
          ), e.localYLabels.forEach((l, o) => {
            D(
              n.value,
              ee(
                a.value.style.chart.dataLabels.formatter,
                l.value,
                ae({
                  p: e.prefix || a.value.style.chart.grid.y.axisLabels.prefix || "",
                  v: l.value,
                  s: e.suffix || a.value.style.chart.grid.y.axisLabels.suffix || "",
                  r: e.rounding || a.value.style.chart.grid.y.axisLabels.rounding || 0
                }),
                { datapoint: l, seriesIndex: o }
              ),
              l.x + a.value.style.chart.grid.y.axisLabels.offsetX,
              l.y,
              {
                align: "right",
                font: `${Math.round(y.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
                color: e.color
              }
            );
          });
        }), h.value.forEach((e) => {
          D(
            n.value,
            e.name,
            y.value / 35,
            t.value.bottom - e.yOffset - e.individualHeight / 2,
            {
              align: "center",
              rotation: -90,
              color: e.color,
              font: `${Math.round(y.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`
            }
          );
        });
      else {
        if (a.value.style.chart.grid.y.verticalLines.show && r.value.end - r.value.start < a.value.style.chart.grid.y.verticalLines.hideUnderXLength)
          for (let e = 0; e < r.value.end - r.value.start + 1; e += 1)
            x(
              n.value,
              [
                { x: t.value.left + t.value.slot * e, y: t.value.top },
                { x: t.value.left + t.value.slot * e, y: t.value.bottom }
              ],
              {
                color: a.value.style.chart.grid.y.verticalLines.color
              }
            );
        else if (a.value.style.chart.grid.y.verticalLines.show && r.value.end - r.value.start >= a.value.style.chart.grid.y.verticalLines.hideUnderXLength)
          for (let e = r.value.start; e < r.value.end; e += 1)
            e % Math.floor((r.value.end - r.value.start) / a.value.style.chart.grid.y.timeLabels.modulo) === 0 && x(
              n.value,
              [
                { x: t.value.left + t.value.slot * (e - r.value.start) + t.value.slot / 2, y: t.value.top },
                { x: t.value.left + t.value.slot * (e - r.value.start) + t.value.slot / 2, y: t.value.bottom }
              ],
              {
                color: a.value.style.chart.grid.y.verticalLines.color
              }
            );
        a.value.style.chart.grid.x.horizontalLines.show && (a.value.style.chart.grid.x.horizontalLines.alternate ? g.value.yLabels.forEach((e, l) => {
          l < g.value.yLabels.length - 1 && we(
            n.value,
            [
              { x: t.value.left, y: e.y },
              { x: t.value.right, y: e.y },
              { x: t.value.right, y: g.value.yLabels[l + 1].y },
              { x: t.value.left, y: g.value.yLabels[l + 1].y }
            ],
            {
              fillColor: l % 2 === 0 ? "transparent" : le(a.value.style.chart.grid.x.horizontalLines.color, a.value.style.chart.grid.x.horizontalLines.opacity),
              strokeColor: "transparent"
            }
          );
        }) : g.value.yLabels.forEach((e) => {
          x(
            n.value,
            [
              { x: t.value.left, y: e.y },
              { x: t.value.right, y: e.y }
            ],
            {
              color: a.value.style.chart.grid.x.horizontalLines.color
            }
          );
        })), a.value.style.chart.grid.y.showAxis && x(
          n.value,
          [
            { x: t.value.left, y: t.value.top },
            { x: t.value.left, y: t.value.bottom }
          ],
          {
            color: a.value.style.chart.grid.y.axisColor,
            lineWidth: a.value.style.chart.grid.y.axisThickness
          }
        ), a.value.style.chart.grid.x.showAxis && x(
          n.value,
          [
            { x: t.value.left, y: t.value.bottom },
            { x: t.value.right, y: t.value.bottom }
          ],
          {
            color: a.value.style.chart.grid.x.axisColor,
            lineWidth: a.value.style.chart.grid.x.axisThickness
          }
        ), a.value.style.chart.grid.zeroLine.show && x(
          n.value,
          [
            { x: t.value.left, y: g.value.zero },
            { x: t.value.right, y: g.value.zero }
          ],
          {
            color: a.value.style.chart.grid.zeroLine.color,
            lineDash: a.value.style.chart.grid.zeroLine.dashed ? [10, 10] : [0, 0]
          }
        ), a.value.style.chart.grid.y.axisLabels.show && g.value.yLabels.forEach((e, l) => {
          D(
            n.value,
            ee(
              a.value.style.chart.dataLabels.formatter,
              e.value,
              ae({
                p: a.value.style.chart.grid.y.axisLabels.prefix || "",
                v: e.value,
                s: a.value.style.chart.grid.y.axisLabels.suffix || "",
                r: a.value.style.chart.grid.y.axisLabels.rounding || 0
              }),
              { datapoint: e, seriesIndex: l }
            ),
            e.x + a.value.style.chart.grid.y.axisLabels.offsetX,
            e.y,
            {
              align: "right",
              font: `${Math.round(y.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
              color: a.value.style.chart.grid.y.axisLabels.color
            }
          );
        });
      }
      a.value.style.chart.grid.y.axisName && D(
        n.value,
        a.value.style.chart.grid.y.axisName,
        y.value - y.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio * 1.2,
        t.value.bottom - t.value.height / 2,
        {
          font: `${Math.round(y.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
          color: a.value.style.chart.color,
          align: "center",
          rotation: 90
        }
      ), a.value.style.chart.grid.x.axisName && D(
        n.value,
        a.value.style.chart.grid.x.axisName,
        y.value / 2,
        P.value,
        {
          font: `${Math.round(y.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
          color: a.value.style.chart.color,
          align: "center"
        }
      );
    }
    function ba(e) {
      for (let l = 0; l < e.coordinatesLine.length; l += 1) {
        const o = (d.value === l ? y.value / 150 : a.value.style.chart.line.plots.show ? y.value / 200 : 0) * a.value.style.chart.line.plots.radiusRatio;
        oa(
          n.value,
          { x: e.coordinatesLine[l].x, y: e.coordinatesLine[l].y },
          o,
          {
            color: a.value.style.chart.backgroundColor,
            fillStyle: e.color
          }
        );
      }
    }
    function xa(e) {
      for (let l = 0; l < e.coordinatesLine.length; l += 1)
        D(
          n.value,
          ee(
            a.value.style.chart.dataLabels.formatter,
            e.coordinatesLine[l].value,
            ae({
              p: e.prefix || "",
              v: e.coordinatesLine[l].value,
              s: e.suffix || "",
              r: e.rounding || 0
            }),
            { datapoint: e.coordinatesLine[l], seriesIndex: l }
          ),
          e.coordinatesLine[l].x,
          e.coordinatesLine[l].y + a.value.style.chart.dataLabels.offsetY,
          {
            align: "center",
            font: `${Math.round(y.value / 40 * a.value.style.chart.dataLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
            color: a.value.style.chart.dataLabels.useSerieColor ? e.color : a.value.style.chart.dataLabels.color,
            strokeColor: a.value.style.chart.backgroundColor,
            lineWidth: 0.8
          }
        );
    }
    function La() {
      for (let e = r.value.start; e < r.value.end; e += 1)
        (r.value.end - r.value.start < a.value.style.chart.grid.y.timeLabels.modulo || r.value.end - r.value.start >= a.value.style.chart.grid.y.timeLabels.modulo && (e % Math.floor((r.value.end - r.value.start) / a.value.style.chart.grid.y.timeLabels.modulo) === 0 || e === d.value + r.value.start)) && D(
          n.value,
          a.value.style.chart.grid.y.timeLabels.values[e] || e + 1,
          t.value.left + t.value.slot * (e - r.value.start) + t.value.slot / 2,
          t.value.bottom + y.value / a.value.style.chart.grid.y.timeLabels.offsetY,
          {
            align: a.value.style.chart.grid.y.timeLabels.rotation === 0 ? "center" : a.value.style.chart.grid.y.timeLabels.rotation > 0 ? "left" : "right",
            font: `${Math.round(y.value / 40 * a.value.style.chart.grid.y.timeLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
            color: le(a.value.style.chart.grid.y.timeLabels.color, d.value !== null ? d.value + r.value.start === e ? 100 : 20 : 100),
            rotation: a.value.style.chart.grid.y.timeLabels.rotation
          }
        );
    }
    function Ye() {
      x(
        n.value,
        [
          { x: t.value.left + t.value.slot * d.value + t.value.slot / 2, y: t.value.top },
          { x: t.value.left + t.value.slot * d.value + t.value.slot / 2, y: t.value.bottom }
        ],
        {
          color: a.value.style.chart.selector.color,
          lineDash: a.value.style.chart.selector.dashed ? [8, 8] : [0, 0],
          lineWidth: 2
        }
      );
    }
    function ka() {
      L.value.forEach((e, l) => {
        for (let o = 0; o < e.coordinatesLine.length; o += 1)
          we(
            n.value,
            [
              {
                x: t.value.left + t.value.slot * o + t.value.slot / 10 + (u.value.stacked ? 0 : t.value.slot / L.value.length * l - (l === 0 ? 0 : t.value.slot / (5 * L.value.length) * l)),
                y: u.value.stacked ? e.localZero : g.value.zero
              },
              {
                x: t.value.left + t.value.slot * o + t.value.slot / 10 + (u.value.stacked ? 0 : t.value.slot / L.value.length * l - (l === 0 ? 0 : t.value.slot / (5 * L.value.length) * l)) + t.value.slot * 0.8 / (u.value.stacked ? 1 : L.value.length),
                y: u.value.stacked ? e.localZero : g.value.zero
              },
              {
                x: t.value.left + t.value.slot * o + t.value.slot / 10 + (u.value.stacked ? 0 : t.value.slot / L.value.length * l - (l === 0 ? 0 : t.value.slot / (5 * L.value.length) * l)) + t.value.slot * 0.8 / (u.value.stacked ? 1 : L.value.length),
                y: e.coordinatesLine[o].y
              },
              {
                x: t.value.left + t.value.slot * o + t.value.slot / 10 + (u.value.stacked ? 0 : t.value.slot / L.value.length * l - (l === 0 ? 0 : t.value.slot / (5 * L.value.length) * l)),
                y: e.coordinatesLine[o].y
              }
            ],
            {
              strokeColor: a.value.style.chart.backgroundColor,
              gradient: {
                type: "linear",
                start: {
                  x: e.coordinatesLine[o].x,
                  y: e.coordinatesLine[o].y
                },
                end: {
                  x: e.coordinatesLine[o].x,
                  y: u.value.stacked ? e.localZero : g.value.zero
                },
                stops: [
                  { offset: 0, color: e.color },
                  { offset: 1, color: ja(e.color, 0.5) }
                ]
              }
            }
          ), u.value.showDataLabels && [!0, void 0].includes(e.dataLabels) && D(
            n.value,
            ee(
              a.value.style.chart.dataLabels.formatter,
              e.coordinatesLine[o].value,
              ae({
                p: e.prefix || "",
                v: e.coordinatesLine[o].value,
                s: e.suffix || "",
                r: e.rounding || 0
              }),
              { datapoint: e.coordinatesLine[o], seriesIndex: o }
            ),
            t.value.left + t.value.slot * o + t.value.slot / 10 + (u.value.stacked ? 0 : t.value.slot / L.value.length * l - (l === 0 ? 0 : t.value.slot / (5 * L.value.length) * l)) + t.value.slot * 0.4 / (u.value.stacked ? 1 : L.value.length),
            (e.coordinatesLine[o].value < 0 ? u.value.stacked ? e.localZero : g.value.zero : e.coordinatesLine[o].y) + a.value.style.chart.dataLabels.offsetY,
            {
              align: "center",
              font: `${Math.round(y.value / 40 * a.value.style.chart.dataLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
              color: a.value.style.chart.dataLabels.useSerieColor ? e.color : a.value.style.chart.dataLabels.color,
              strokeColor: a.value.style.chart.backgroundColor,
              lineWidth: 0.8
            }
          );
      });
    }
    function Ca(e) {
      e.useArea ? u.value.stacked ? ra(
        n.value,
        [{ x: e.coordinatesLine[0].x, y: e.localZero }, ...e.coordinatesLine, { x: e.coordinatesLine.at(-1).x, y: e.localZero }],
        {
          fillColor: le(e.color, a.value.style.chart.area.opacity),
          strokeColor: "transparent"
        }
      ) : ra(
        n.value,
        [{ x: e.coordinatesLine[0].x, y: g.value.zero }, ...e.coordinatesLine, { x: e.coordinatesLine.at(-1).x, y: g.value.zero }],
        {
          fillColor: le(e.color, a.value.style.chart.area.opacity),
          strokeColor: "transparent"
        }
      ) : x(n.value, e.coordinatesLine, {
        color: e.color,
        lineWidth: 3
      });
    }
    function wa() {
      h.value.forEach((e, l) => {
        x(
          n.value,
          [
            { x: t.value.left, y: t.value.bottom - e.yOffset },
            { x: t.value.right, y: t.value.bottom - e.yOffset }
          ],
          {
            color: a.value.style.chart.grid.x.horizontalLines.color,
            lineWidth: 1
          }
        );
      });
    }
    function xe() {
      ma(), A.value ? (T.value && d.value !== null && a.value.style.chart.selector.show && Ye(), ka(), u.value.stacked && a.value.style.chart.grid.x.showAxis && wa(), ga.value.forEach((e) => {
        (e.type === "line" || !e.type) && Ca(e), T.value && (ba(e), u.value.showDataLabels && [!0, void 0].includes(e.dataLabels) && xa(e));
      }), ye.value = Qa(I.value)) : (ye.value && (n.value.clearRect(0, 0, 1e4, 1e4), n.value.drawImage(ye.value, 0, 0)), T.value && d.value !== null && a.value.style.chart.selector.show && Ye(), T.value && d.value !== null && h.value.forEach((e) => {
        if (e.type === "line" || !e.type || e.type === "plot") {
          if (!e.coordinatesLine[d.value]) return;
          e.coordinatesLine[d.value].x !== void 0 && e.coordinatesLine[d.value].y !== void 0 && oa(
            n.value,
            {
              x: e.coordinatesLine[d.value].x,
              y: e.coordinatesLine[d.value].y
            },
            y.value / 150 * a.value.style.chart.line.plots.radiusRatio,
            {
              color: a.value.style.chart.backgroundColor,
              fillStyle: e.color
            }
          );
        }
      })), a.value.style.chart.grid.y.timeLabels.show && La(), A.value = !1;
    }
    const ue = qa(() => {
      T.value = !0, pa();
    }, $.value > 200 ? 10 : 1, !T.value);
    function za(e) {
      const { left: l } = I.value.getBoundingClientRect(), o = e.clientX - l;
      if (o * 2 < t.value.left || o * 2 > t.value.right) {
        te.value = !1, d.value = null;
        return;
      }
      const c = o * 2 - t.value.left;
      if (d.value = Math.floor(c / t.value.slot), te.value = !0, !T.value) return;
      let i = "";
      const k = a.value.style.chart.tooltip.customFormat;
      ta(k) && Ga(() => k({
        seriesIndex: d.value,
        datapoint: h.value.map((s) => ({
          shape: s.shape || null,
          name: s.name,
          color: s.color,
          type: s.type || "line",
          value: s.series.find((C, M) => M === d.value)
        })),
        series: h.value,
        config: a.value
      })) ? oe.value = k({
        seriesIndex: d.value,
        datapoint: h.value.map((s) => ({
          shape: s.shape || null,
          name: s.name,
          color: s.color,
          type: s.type || "line",
          value: s.series.find((C, M) => M === d.value)
        })),
        series: h.value,
        config: a.value
      }) : (a.value.style.chart.grid.y.timeLabels.values.slice(r.value.start, r.value.end)[d.value] && (i += `<div style="padding-bottom: 6px; margin-bottom: 4px; border-bottom: 1px solid ${a.value.style.chart.tooltip.borderColor}; width:100%">${a.value.style.chart.grid.y.timeLabels.values.slice(r.value.start, r.value.end)[d.value]}</div>`), i += ya.value.join(""), oe.value = i), T.value = !1;
    }
    H(() => d.value, (e) => {
      ue();
    }), H(() => r.value, (e) => {
      A.value = !0, xe();
    }, {
      deep: !0
    }), H(() => u.value.showDataLabels, (e) => {
      A.value = !0, xe();
    }), H(() => u.value.stacked, (e) => {
      A.value = !0, T.value = !0, ue();
    });
    function Sa() {
      te.value = !1, d.value = null, oe.value = "";
    }
    const se = v(null), ne = v(null);
    ea(() => {
      Le();
    });
    function Le() {
      if (Ba(f.dataset) ? Ya({
        componentName: "VueUiXyCanvas",
        type: "dataset"
      }) : I.value && (n.value = I.value.getContext("2d", { willReadFrequently: !0 })), a.value.responsive) {
        const e = Ja(() => {
          const { width: l, height: o } = Ka({
            chart: G.value,
            title: a.value.style.chart.title.text ? Te.value : null,
            legend: a.value.style.chart.legend.show ? Me.value : null,
            slicer: a.value.style.chart.zoom.show && $.value > 1 ? Oe.value : null,
            source: Pe.value
          });
          requestAnimationFrame(() => {
            De.value = `${l} / ${o}`;
          });
        });
        se.value = new ResizeObserver(e), se.value.observe(G.value.parentNode);
      }
      ne.value = new ResizeObserver((e) => {
        for (const l of e)
          l.contentBoxSize && j.value && (A.value = !0, ue());
      }), ne.value.observe(j.value), Be();
    }
    Oa(() => {
      ne.value && ne.value.disconnect(), se.value && se.value.disconnect();
    });
    function Ve(e) {
      va("selectLegend", h.value.find((l) => l.absoluteIndex === e)), S.value.includes(e) ? S.value = S.value.filter((l) => l !== e) : S.value.push(e), A.value = !0, ue();
    }
    const Ze = m(() => X.value.map((e, l) => ({
      ...e,
      name: e.name,
      color: la(e.color) || Ue.value[l] || U[l] || U[l % U.length],
      shape: e.shape || "circle",
      prefix: e.prefix || "",
      suffix: e.suffix || "",
      rounding: e.rounding || 0
    })).map((e) => ({
      ...e,
      opacity: S.value.includes(e.absoluteIndex) ? 0.5 : 1,
      segregate: () => Ve(e.absoluteIndex),
      isSegregated: S.value.includes(e.absoluteIndex)
    }))), $a = m(() => ({
      cy: "donut-div-legend",
      backgroundColor: a.value.style.chart.legend.backgroundColor,
      color: a.value.style.chart.legend.color,
      fontSize: a.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: a.value.style.chart.legend.bold ? "bold" : ""
    })), ie = m(() => {
      const e = [""].concat(h.value.map((i) => i.name)).concat(' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>');
      let l = [];
      for (let i = 0; i < $.value; i += 1) {
        const k = h.value.map((s) => s.series[i] ?? 0).reduce((s, C) => s + C, 0);
        l.push([a.value.style.chart.grid.y.timeLabels.values.slice(r.value.start, r.value.end)[i] ?? i + 1].concat(h.value.map((s) => (s.series[i] ?? 0).toFixed(a.value.table.rounding))).concat((k ?? 0).toFixed(a.value.table.rounding)));
      }
      const o = {
        th: {
          backgroundColor: a.value.table.th.backgroundColor,
          color: a.value.table.th.color,
          outline: a.value.table.th.outline
        },
        td: {
          backgroundColor: a.value.table.td.backgroundColor,
          color: a.value.table.td.color,
          outline: a.value.table.td.outline
        },
        breakpoint: a.value.table.responsiveBreakpoint
      }, c = [a.value.table.columnNames.period].concat(h.value.map((i) => i.name)).concat(a.value.table.columnNames.total);
      return { head: e, body: l.slice(0, r.value.end - r.value.start), config: o, colNames: c };
    }), Ge = m(() => {
      if (h.value.length === 0) return { head: [], body: [], config: {}, columnNames: [] };
      const e = h.value.map((o) => ({
        label: o.name,
        color: o.color,
        type: o.type
      })), l = [];
      for (let o = r.value.start; o < r.value.end; o += 1) {
        const c = [a.value.style.chart.grid.y.timeLabels.values[o] || o + 1];
        h.value.forEach((i) => {
          c.push(Number((i.series[o] || 0).toFixed(a.value.table.rounding)));
        }), l.push(c);
      }
      return { head: e, body: l };
    });
    function je() {
      const e = [[a.value.style.chart.title.text], [a.value.style.chart.title.subtitle.text], [""]], l = ["", ...Ge.value.head.map((k) => k.label)], o = Ge.value.body, c = e.concat([l]).concat(o), i = Va(c);
      Za({ csvContent: i, title: a.value.style.chart.title.text || "vue-ui-xy-canvas" });
    }
    function Ia() {
      return h.value;
    }
    function qe() {
      u.value.showTable = !u.value.showTable;
    }
    function Je() {
      u.value.showDataLabels = !u.value.showDataLabels;
    }
    function Ke() {
      u.value.stacked = !u.value.stacked;
    }
    function Qe() {
      u.value.showTooltip = !u.value.showTooltip;
    }
    const ve = v(!1);
    function ke() {
      ve.value = !ve.value;
    }
    return sa({
      getData: Ia,
      generateCsv: je,
      generatePdf: He,
      generateImage: _e,
      toggleTable: qe,
      toggleLabels: Je,
      toggleStack: Ke,
      toggleTooltip: Qe,
      toggleAnnotator: ke
    }), (e, l) => (w(), K("div", {
      style: Y(`width:100%; position:relative; ${a.value.responsive ? "height: 100%" : ""}`),
      ref_key: "xy",
      ref: G,
      id: `xy_canvas_${he.value}`,
      class: Pa(`vue-ui-donut ${re.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      onMouseenter: l[5] || (l[5] = () => z(Re)(!0)),
      onMouseleave: l[6] || (l[6] = () => z(Re)(!1))
    }, [
      a.value.style.chart.title.text ? (w(), K("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: Te,
        style: Y(`width:100%;background:${a.value.style.chart.backgroundColor};`)
      }, [
        (w(), E(ll, {
          key: `title_${fe.value}`,
          config: {
            title: {
              cy: "xy-canvas-title",
              ...a.value.style.chart.title
            },
            subtitle: {
              cy: "xy-canvas-subtitle",
              ...a.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 4)) : _("", !0),
      a.value.userOptions.show && me.value && (z(Fe) || z(be)) ? (w(), E(rl, {
        ref: "details",
        key: `user_option_${Ie.value}`,
        backgroundColor: a.value.style.chart.backgroundColor,
        color: a.value.style.chart.color,
        isPrinting: z(Ae),
        isImaging: z(Ne),
        uid: he.value,
        hasTooltip: a.value.userOptions.buttons.tooltip && a.value.style.chart.tooltip.show,
        hasPdf: a.value.userOptions.buttons.pdf,
        hasImg: a.value.userOptions.buttons.img,
        hasXls: a.value.userOptions.buttons.csv,
        hasLabel: a.value.userOptions.buttons.labels,
        hasStack: ze.dataset.length > 1 && a.value.userOptions.buttons.stack,
        hasFullscreen: a.value.userOptions.buttons.fullscreen,
        hasTable: r.value.end - r.value.start < 200 && a.value.userOptions.buttons.table,
        isFullscreen: re.value,
        isTooltip: u.value.showTooltip,
        isStacked: u.value.stacked,
        titles: { ...a.value.userOptions.buttonTitles },
        chartElement: G.value,
        position: a.value.userOptions.position,
        hasAnnotator: a.value.userOptions.buttons.annotator,
        isAnnotation: ve.value,
        onToggleFullscreen: da,
        onGeneratePdf: z(He),
        onGenerateCsv: je,
        onGenerateImage: z(_e),
        onToggleTable: qe,
        onToggleLabels: Je,
        onToggleStack: Ke,
        onToggleTooltip: Qe,
        onToggleAnnotator: ke,
        style: Y({
          visibility: z(Fe) ? z(be) ? "visible" : "hidden" : "visible"
        })
      }, Ra({ _: 2 }, [
        e.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: p(() => [
            b(e.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        e.$slots.optionPdf ? {
          name: "optionPdf",
          fn: p(() => [
            b(e.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        e.$slots.optionCsv ? {
          name: "optionCsv",
          fn: p(() => [
            b(e.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        e.$slots.optionImg ? {
          name: "optionImg",
          fn: p(() => [
            b(e.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        e.$slots.optionTable ? {
          name: "optionTable",
          fn: p(() => [
            b(e.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        e.$slots.optionLabels ? {
          name: "optionLabels",
          fn: p(() => [
            b(e.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        e.$slots.optionStack ? {
          name: "optionStack",
          fn: p(() => [
            b(e.$slots, "optionStack", {}, void 0, !0)
          ]),
          key: "6"
        } : void 0,
        e.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: p(({ toggleFullscreen: o, isFullscreen: c }) => [
            b(e.$slots, "optionFullscreen", V(Z({ toggleFullscreen: o, isFullscreen: c })), void 0, !0)
          ]),
          key: "7"
        } : void 0,
        e.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: p(({ toggleAnnotator: o, isAnnotator: c }) => [
            b(e.$slots, "optionAnnotator", V(Z({ toggleAnnotator: o, isAnnotator: c })), void 0, !0)
          ]),
          key: "8"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasLabel", "hasStack", "hasFullscreen", "hasTable", "isFullscreen", "isTooltip", "isStacked", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage", "style"])) : _("", !0),
      Q("div", {
        class: "vue-ui-xy-canvas",
        style: Y(`position: relative; aspect-ratio: ${De.value}`),
        ref_key: "container",
        ref: j
      }, [
        me.value ? (w(), K("canvas", {
          key: 0,
          ref_key: "canvas",
          ref: I,
          style: { width: "100%", height: "100%" },
          onMousemove: l[0] || (l[0] = (o) => za(o)),
          onMouseleave: Sa
        }, null, 544)) : (w(), E(nl, {
          key: 1,
          config: {
            type: "line",
            style: {
              backgroundColor: a.value.style.chart.backgroundColor,
              line: {
                axis: {
                  color: "#CCCCCC"
                },
                path: {
                  color: "#CCCCCC",
                  strokeWidth: 0.5
                }
              }
            }
          }
        }, null, 8, ["config"])),
        Fa(el, {
          show: u.value.showTooltip && te.value,
          backgroundColor: a.value.style.chart.tooltip.backgroundColor,
          color: a.value.style.chart.tooltip.color,
          fontSize: a.value.style.chart.tooltip.fontSize,
          borderRadius: a.value.style.chart.tooltip.borderRadius,
          borderColor: a.value.style.chart.tooltip.borderColor,
          borderWidth: a.value.style.chart.tooltip.borderWidth,
          position: a.value.style.chart.tooltip.position,
          offsetY: a.value.style.chart.tooltip.offsetY,
          parent: I.value,
          content: oe.value,
          isFullscreen: re.value,
          backgroundOpacity: a.value.style.chart.tooltip.backgroundOpacity,
          isCustom: z(ta)(a.value.style.chart.tooltip.customFormat)
        }, {
          "tooltip-before": p(() => [
            b(e.$slots, "tooltip-before", V(Z({ ...Se.value })), void 0, !0)
          ]),
          "tooltip-after": p(() => [
            b(e.$slots, "tooltip-after", V(Z({ ...Se.value })), void 0, !0)
          ]),
          _: 3
        }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "position", "offsetY", "parent", "content", "isFullscreen", "backgroundOpacity", "isCustom"])
      ], 4),
      Q("div", {
        ref_key: "chartSlicer",
        ref: Oe,
        style: Y(`width:100%;background:${a.value.style.chart.backgroundColor}`),
        "data-html2canvas-ignore": ""
      }, [
        a.value.style.chart.zoom.show && $.value > 1 ? (w(), E(tl, {
          ref_key: "slicerComponent",
          ref: B,
          key: `slicer_${$e.value}`,
          background: a.value.style.chart.zoom.color,
          borderColor: a.value.style.chart.backgroundColor,
          fontSize: a.value.style.chart.zoom.fontSize,
          useResetSlot: a.value.style.chart.zoom.useResetSlot,
          labelLeft: a.value.style.chart.grid.y.timeLabels.values[r.value.start] ? a.value.style.chart.grid.y.timeLabels.values[r.value.start] : "",
          labelRight: a.value.style.chart.grid.y.timeLabels.values[r.value.end - 1] ? a.value.style.chart.grid.y.timeLabels.values[r.value.end - 1] : "",
          textColor: a.value.style.chart.color,
          inputColor: a.value.style.chart.zoom.color,
          selectColor: a.value.style.chart.zoom.highlightColor,
          max: $.value,
          min: 0,
          valueStart: r.value.start,
          valueEnd: r.value.end,
          start: r.value.start,
          "onUpdate:start": l[1] || (l[1] = (o) => r.value.start = o),
          end: r.value.end,
          "onUpdate:end": l[2] || (l[2] = (o) => r.value.end = o),
          refreshStartPoint: a.value.style.chart.zoom.startIndex !== null ? a.value.style.chart.zoom.startIndex : 0,
          refreshEndPoint: a.value.style.chart.zoom.endIndex !== null ? a.value.style.chart.zoom.endIndex + 1 : $.value,
          enableRangeHandles: a.value.style.chart.zoom.enableRangeHandles,
          enableSelectionDrag: a.value.style.chart.zoom.enableSelectionDrag,
          onReset: Xe
        }, {
          "reset-action": p(({ reset: o }) => [
            b(e.$slots, "reset-action", V(Z({ reset: o })), void 0, !0)
          ]),
          _: 3
        }, 8, ["background", "borderColor", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "max", "valueStart", "valueEnd", "start", "end", "refreshStartPoint", "refreshEndPoint", "enableRangeHandles", "enableSelectionDrag"])) : _("", !0)
      ], 4),
      Q("div", {
        ref_key: "chartLegend",
        ref: Me
      }, [
        a.value.style.chart.legend.show && me.value ? (w(), E(al, {
          legendSet: Ze.value,
          config: $a.value,
          key: `legend_${pe.value}`,
          onClickMarker: l[3] || (l[3] = ({ i: o }) => Ve(o))
        }, {
          item: p(({ legend: o, index: c }) => [
            Q("div", {
              onClick: (i) => o.segregate(),
              style: Y(`opacity:${S.value.includes(c) ? 0.5 : 1}`)
            }, aa(o.name), 13, hl)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : b(e.$slots, "legend", {
          key: 1,
          legend: Ze.value
        }, void 0, !0)
      ], 512),
      e.$slots.watermark ? (w(), K("div", yl, [
        b(e.$slots, "watermark", V(Z({ isPrinting: z(Ae) || z(Ne) })), void 0, !0)
      ])) : _("", !0),
      e.$slots.source ? (w(), K("div", {
        key: 3,
        ref_key: "source",
        ref: Pe,
        dir: "auto"
      }, [
        b(e.$slots, "source", {}, void 0, !0)
      ], 512)) : _("", !0),
      r.value.end - r.value.start < 200 ? (w(), E(ul, {
        key: 4,
        hideDetails: "",
        config: {
          open: u.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: a.value.style.chart.backgroundColor,
            color: a.value.style.chart.color
          },
          head: {
            backgroundColor: a.value.style.chart.backgroundColor,
            color: a.value.style.chart.color
          }
        }
      }, {
        content: p(() => [
          (w(), E(sl, {
            key: `table_${ge.value}`,
            colNames: ie.value.colNames,
            head: ie.value.head,
            body: ie.value.body,
            config: ie.value.config,
            title: `${a.value.style.chart.title.text}${a.value.style.chart.title.subtitle.text ? ` : ${a.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: l[4] || (l[4] = (o) => u.value.showTable = !1)
          }, {
            th: p(({ th: o }) => [
              Q("div", { innerHTML: o }, null, 8, fl)
            ]),
            td: p(({ td: o }) => [
              Ea(aa(o), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : _("", !0),
      a.value.userOptions.buttons.annotator && h.value.length ? (w(), E(il, {
        key: 5,
        parent: G.value,
        backgroundColor: a.value.style.chart.backgroundColor,
        color: a.value.style.chart.color,
        active: ve.value,
        onClose: ke
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : _("", !0)
    ], 46, dl));
  }
}, Pl = /* @__PURE__ */ cl(gl, [["__scopeId", "data-v-13fe7bc4"]]);
export {
  Pl as default
};
