import { useCssVars as De, computed as y, createElementBlock as v, openBlock as r, createElementVNode as S, renderSlot as i, createVNode as ne, normalizeStyle as q, ref as n, watch as se, onMounted as Ee, onBeforeUnmount as Ge, unref as d, createBlock as A, createCommentVNode as w, createSlots as Le, withCtx as m, normalizeProps as M, guardReactiveProps as _, normalizeClass as ke, Fragment as Xe, renderList as je, toDisplayString as we, createTextVNode as qe, nextTick as $e } from "vue";
import { u as He, a4 as Ye, v as Je, c as xe, t as Ke, p as j, a as Qe, o as Ze, e as Te, g as et, f as tt, X as ot, q as at, r as lt, x as st } from "./index-CgWFTIG9.js";
import { _ as nt } from "./Title-DlRsN8Ie.js";
import { u as rt, U as ut } from "./usePrinter-DVQLRjmi.js";
import { d as it, t as ct, u as dt } from "./useResponsive-CoxXLe23.js";
import vt from "./vue-ui-accordion-Cms_Ab9s.js";
import { D as ht } from "./DataTable-DTuvAsnZ.js";
import mt from "./BaseIcon-DCvCVV6b.js";
import { _ as Fe } from "./_plugin-vue_export-helper-CHgC5LLL.js";
import { u as Se } from "./useNestedProp-DSDe8aSH.js";
import { _ as ft } from "./PackageVersion-Cuuq__DB.js";
import { _ as pt } from "./Tooltip-Dvk5hWuz.js";
import { P as gt } from "./PenAndPaper-7DCNMpkg.js";
import { u as yt } from "./useUserOptionState-BIvW1Kz7.js";
const bt = { "data-html2canvas-ignore": "" }, Ct = {
  key: 0,
  class: "reset-wrapper"
}, kt = {
  key: 1,
  class: "reset-wrapper"
}, wt = { class: "mono-slicer" }, $t = ["min", "max", "value"], xt = {
  __name: "MonoSlicer",
  props: {
    min: {
      type: Number,
      default: 0
    },
    max: {
      type: Number,
      default: 0
    },
    inputColor: {
      type: String,
      default: "#1A1A1A"
    },
    background: {
      type: String,
      default: "#FFFFFF"
    },
    borderColor: {
      type: String,
      default: "#FFFFFF"
    },
    selectColor: {
      type: String,
      default: "#4A4A4A"
    },
    textColor: {
      type: String,
      default: "#1A1A1A"
    },
    useResetSlot: {
      type: Boolean,
      default: !1
    },
    value: {
      type: Number,
      default: 0
    },
    source: {
      type: Number,
      default: 0
    }
  },
  emits: ["update:value", "reset"],
  setup(f, { emit: H }) {
    De((T) => ({
      "782b8172": h.value,
      "102109e6": I.value,
      "642212d7": x.value,
      "1f5369d4": f.selectColor,
      "22b98ab8": F.value
    }));
    const p = f, h = y(() => p.inputColor), F = y(() => p.background), x = y(() => `${p.selectColor}33`), I = y(() => p.borderColor), W = H;
    function C() {
      W("reset");
    }
    const V = y(() => {
      const T = p.max - p.min, b = 0, N = (p.value - p.min) / T * 100;
      return {
        left: `${b}%`,
        width: `${N - b}%`,
        background: p.selectColor
      };
    });
    return (T, b) => (r(), v("div", bt, [
      f.value !== f.source ? (r(), v("div", Ct, [
        f.useResetSlot ? i(T.$slots, "reset-action", {
          key: 1,
          reset: C
        }, void 0, !0) : (r(), v("button", {
          key: 0,
          "data-cy-reset": "",
          tabindex: "0",
          role: "button",
          class: "vue-data-ui-refresh-button",
          onClick: C
        }, [
          ne(mt, {
            name: "refresh",
            stroke: f.textColor
          }, null, 8, ["stroke"])
        ]))
      ])) : (r(), v("div", kt)),
      S("div", wt, [
        b[1] || (b[1] = S("div", { class: "slider-track" }, null, -1)),
        S("div", {
          class: "range-highlight",
          style: q(V.value)
        }, null, 4),
        S("input", {
          type: "range",
          min: f.min,
          max: f.max,
          value: Number(f.value),
          onInput: b[0] || (b[0] = (N) => W("update:value", Number(N.target.value)))
        }, null, 40, $t)
      ])
    ]));
  }
}, Tt = /* @__PURE__ */ Fe(xt, [["__scopeId", "data-v-b4e6aee9"]]), St = ["id"], Ft = ["xmlns", "viewBox"], Nt = ["width", "height"], zt = ["transform"], Ot = ["fill", "font-weight", "x", "y", "font-size", "transform", "onMouseover"], Pt = {
  key: 4,
  class: "vue-data-ui-watermark"
}, At = ["innerHTML"], Mt = {
  __name: "vue-ui-word-cloud",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: [Array, String],
      default() {
        return [];
      }
    }
  },
  setup(f, { expose: H }) {
    const { vue_ui_word_cloud: p } = He(), h = f, F = y({
      get() {
        return !!h.dataset && h.dataset.length;
      },
      set(t) {
        return t;
      }
    }), x = n(typeof h.dataset == "string" ? Ye(h.dataset) : h.dataset.map((t, a) => ({
      ...t,
      value: Je(t.value)
    }))), I = n(xe()), W = n(0), C = n(null), V = n(null), T = n(null), b = n(0), N = n(0), Y = n(!1), e = y({
      get: () => ie(),
      set: (t) => t
    }), { userOptionsVisible: J, setUserOptionsVisibility: re, keepUserOptionState: ue } = yt({ config: e.value });
    function ie() {
      const t = Se({
        userConfig: h.config,
        defaultConfig: p
      });
      return t.theme ? {
        ...Se({
          userConfig: Qe.vue_ui_word_cloud[t.theme] || h.config,
          defaultConfig: t
        }),
        customPalette: Ke[t.theme] || j
      } : t;
    }
    se(() => h.config, (t) => {
      e.value = ie(), J.value = !e.value.userOptions.showOnChartHover, de(), b.value += 1, N.value += 1, K(), c.value.showTable = e.value.table.show, c.value.showTooltip = e.value.style.chart.tooltip.show;
    }, { deep: !0 });
    const ce = n(null), z = n(0), s = n({
      width: e.value.style.chart.width,
      height: e.value.style.chart.height,
      maxFontSize: e.value.style.chart.words.maxFontSize,
      minFontSize: e.value.style.chart.words.minFontSize
    }), Ne = ct(() => {
      const { width: t, height: a } = dt({
        chart: C.value,
        title: e.value.style.chart.title.text ? V.value : null,
        slicer: e.value.style.chart.zoom.show && ce.value,
        source: T.value
      });
      requestAnimationFrame(() => {
        s.value.width = t, s.value.height = a, $e(Z);
      });
    });
    se(() => z.value, () => {
      ze();
    });
    const ze = it(() => {
      Z();
    }, 10);
    function K() {
      z.value = Q.value;
    }
    const B = n(null);
    Ee(() => {
      de(), K();
    });
    function de() {
      Ze(h.dataset) ? Te({
        componentName: "VueUiWordCloud",
        type: "dataset"
      }) : x.value.forEach((t, a) => {
        et({
          datasetObject: t,
          requiredAttributes: ["name", "value"]
        }).forEach((o) => {
          F.value = !1, Te({
            componentName: "VueUiWordCloud",
            type: "datasetSerieAttribute",
            property: o,
            index: a
          });
        });
      }), e.value.responsive && (B.value = new ResizeObserver(Ne), B.value.observe(C.value.parentNode));
    }
    Ge(() => {
      B.value && B.value.disconnect();
    });
    const { isPrinting: ve, isImaging: he, generatePdf: me, generateImage: fe } = rt({
      elementId: `wordCloud_${I.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-word-cloud"
    }), c = n({
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    });
    function Oe(t, a, o = "Arial") {
      const l = document.createElement("canvas").getContext("2d");
      return l.font = `${a}px ${e.value.style.chart.words.bold ? "bold" : "normal"} ${o}`, {
        width: l.measureText(t).width + e.value.style.chart.words.proximity,
        height: a
      };
    }
    function Pe(t, a) {
      return t.x < a.x + a.width && t.x + t.width > a.x && t.y < a.y + a.height && t.y + t.height > a.y;
    }
    function Ae(t, a, o) {
      const u = [], l = { x: -a / 2, y: -o / 2, width: a, height: o }, g = 0, k = 0;
      return t.forEach((P) => {
        let ae = !1;
        for (let X = 0; X < Math.max(a, o) / 2 && !ae; X += e.value.style.chart.words.packingWeight)
          for (let le = 0; le < 360 && !ae; le += e.value.style.chart.words.packingWeight) {
            const Ce = le * Math.PI / 180, We = g + X * Math.cos(Ce) - P.width / 2, Re = k + X * Math.sin(Ce) - P.height / 2, $ = { ...P, x: We, y: Re }, Ue = $.x >= l.x && $.y >= l.y && $.x + $.width <= l.x + l.width && $.y + $.height <= l.y + l.height, Ve = u.some((Be) => Pe($, Be));
            Ue && !Ve && (u.push($), ae = !0);
          }
      }), u;
    }
    const R = n([]);
    se(() => h.dataset, Z, { immediate: !0 });
    const Q = y(() => Math.round(Math.min(...x.value.map((t) => t.value)))), pe = y(() => Math.round(Math.max(...x.value.map((t) => t.value))));
    function Z() {
      const t = [...x.value].filter((l) => l.value >= z.value).map((l) => l.value), a = Math.max(...t), o = Math.min(...t), u = [...x.value].filter((l) => l.value >= z.value).map((l, g) => {
        let k = (l.value - o) / (a - o) * (s.value.maxFontSize - s.value.minFontSize) + s.value.minFontSize;
        k = isNaN(k) ? s.value.minFontSize : k;
        const P = Oe(l.name, k);
        return {
          ...l,
          id: xe(),
          fontSize: k,
          width: P.width,
          height: P.height,
          color: e.value.style.chart.words.usePalette ? e.value.customPalette[g] || e.value.customPalette[g % e.value.customPalette.length] || j[g] || j[g % j.length] : e.value.style.chart.words.color
        };
      });
      R.value = Ae(u, s.value.width, s.value.height).sort((l, g) => g.fontSize - l.fontSize);
    }
    const D = y(() => {
      const t = R.value.map((o) => ({
        name: o.name,
        color: o.color
      })), a = R.value.map((o) => o.value);
      return { head: t, body: a };
    });
    function ge() {
      $e(() => {
        const t = D.value.head.map((u, l) => [[
          u.name
        ], [D.value.body[l]]]), a = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], [e.value.table.columnNames.value]]].concat(t), o = at(a);
        lt({ csvContent: o, title: e.value.style.chart.title.text || "vue-ui-word-cloud" });
      });
    }
    const E = y(() => {
      const t = [
        e.value.table.columnNames.series,
        e.value.table.columnNames.value
      ], a = D.value.head.map((l, g) => {
        const k = tt({ p: e.value.table.td.prefix, v: D.value.body[g], s: e.value.table.td.suffix, r: e.value.table.td.roundingValue });
        return [
          {
            color: l.color,
            name: l.name
          },
          k
        ];
      }), o = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.value
        ],
        head: t,
        body: a,
        config: o
      };
    }), G = n(!1);
    function Me(t) {
      G.value = t, W.value += 1;
    }
    function _e() {
      return R.value;
    }
    function ye() {
      c.value.showTable = !c.value.showTable;
    }
    function be() {
      c.value.showTooltip = !c.value.showTooltip;
    }
    const L = n(!1);
    function ee() {
      L.value = !L.value;
    }
    H({
      getData: _e,
      generateCsv: ge,
      generatePdf: me,
      generateImage: fe,
      toggleTable: ye,
      toggleTooltip: be,
      toggleAnnotator: ee
    });
    const O = n(null), U = n(!1), te = n(""), oe = n(null);
    function Ie(t) {
      if (!c.value.showTooltip) return;
      O.value = t.id, oe.value = { datapoint: t, config: e.value };
      const a = e.value.style.chart.tooltip.customFormat;
      if (U.value = !1, st(a))
        try {
          const o = a({
            datapoint: t,
            config: e.value
          });
          typeof o == "string" && (te.value = o, U.value = !0);
        } catch {
          console.warn("Custom format cannot be applied."), U.value = !1;
        }
      if (!U.value) {
        let o = `<svg viewBox="0 0 10 10" height="${e.value.style.chart.tooltip.fontSize}"><circle cx="5" cy="5" r="5" fill="${t.color}"/></svg><span>${t.name}:</span><b>${(t.value || 0).toFixed(e.value.style.chart.tooltip.roundingValue)}</b>`;
        te.value = `<div dir="auto" style="display:flex; gap:4px; align-items:center; jsutify-content:center;">${o}</div>`;
      }
      Y.value = !0;
    }
    return (t, a) => (r(), v("div", {
      class: "vue-ui-word-cloud",
      ref_key: "wordCloudChart",
      ref: C,
      id: `wordCloud_${I.value}`,
      style: q(`width: 100%; font-family:${e.value.style.fontFamily};background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height:100%" : ""}`),
      onMouseenter: a[3] || (a[3] = () => d(re)(!0)),
      onMouseleave: a[4] || (a[4] = () => d(re)(!1))
    }, [
      e.value.userOptions.buttons.annotator ? (r(), A(gt, {
        key: 0,
        parent: C.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: L.value,
        onClose: ee
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : w("", !0),
      e.value.style.chart.title.text ? (r(), v("div", {
        key: 1,
        ref_key: "chartTitle",
        ref: V,
        style: "width:100%;background:transparent;padding-bottom:24px"
      }, [
        (r(), A(nt, {
          key: `title_${b.value}`,
          config: {
            title: {
              ...e.value.style.chart.title
            },
            subtitle: {
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : w("", !0),
      e.value.userOptions.show && F.value && (d(ue) || d(J)) ? (r(), A(ut, {
        ref: "details",
        key: `user_option_${W.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: d(ve),
        isImaging: d(he),
        uid: I.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: G.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: C.value,
        position: e.value.userOptions.position,
        hasTooltip: e.value.style.chart.tooltip.show && e.value.userOptions.buttons.tooltip,
        isTooltip: c.value.showTooltip,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: L.value,
        onToggleFullscreen: Me,
        onGeneratePdf: d(me),
        onGenerateCsv: ge,
        onGenerateImage: d(fe),
        onToggleTable: ye,
        onToggleTooltip: be,
        onToggleAnnotator: ee,
        style: q({
          visibility: d(ue) ? d(J) ? "visible" : "hidden" : "visible"
        })
      }, Le({ _: 2 }, [
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: m(() => [
            i(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: m(() => [
            i(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: m(() => [
            i(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: m(() => [
            i(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: m(({ toggleFullscreen: o, isFullscreen: u }) => [
            i(t.$slots, "optionFullscreen", M(_({ toggleFullscreen: o, isFullscreen: u })), void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: m(({ toggleAnnotator: o, isAnnotator: u }) => [
            i(t.$slots, "optionAnnotator", M(_({ toggleAnnotator: o, isAnnotator: u })), void 0, !0)
          ]),
          key: "5"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasXls", "hasImg", "hasTable", "hasFullscreen", "isFullscreen", "titles", "chartElement", "position", "hasTooltip", "isTooltip", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage", "style"])) : w("", !0),
      F.value ? (r(), v("svg", {
        key: 3,
        class: ke({ "vue-data-ui-fullscreen--on": G.value, "vue-data-ui-fulscreen--off": !G.value }),
        xmlns: d(ot),
        viewBox: `0 0 ${s.value.width <= 0 ? 10 : s.value.width} ${s.value.height <= 0 ? 10 : s.value.height}`,
        style: "overflow:visible;background:transparent;"
      }, [
        ne(ft),
        t.$slots["chart-background"] ? (r(), v("foreignObject", {
          key: 0,
          x: 0,
          y: 0,
          width: s.value.width <= 0 ? 10 : s.value.width,
          height: s.value.height <= 0 ? 10 : s.value.height,
          style: {
            pointerEvents: "none"
          }
        }, [
          i(t.$slots, "chart-background", {}, void 0, !0)
        ], 8, Nt)) : w("", !0),
        S("g", {
          transform: `translate(${(s.value.width <= 0 ? 10 : s.value.width) / 2}, ${(s.value.height <= 0 ? 10 : s.value.height) / 2})`
        }, [
          (r(!0), v(Xe, null, je(R.value, (o, u) => (r(), v("g", null, [
            (r(), v("text", {
              fill: o.color,
              "font-weight": e.value.style.chart.words.bold ? "bold" : "normal",
              key: u,
              x: o.x,
              y: o.y,
              "font-size": o.fontSize,
              transform: `translate(${o.width / 2}, ${o.height / 2})`,
              class: ke({ animated: e.value.useCssAnimation, "word-selected": O.value && O.value === o.id && c.value.showTooltip, "word-not-selected": O.value && O.value !== o.id && c.value.showTooltip }),
              "text-anchor": "middle",
              "dominant-baseline": "central",
              onMouseover: (l) => Ie(o),
              onMouseleave: a[0] || (a[0] = (l) => {
                O.value = null, Y.value = !1;
              }),
              style: q(`animation-delay:${u * e.value.animationDelayMs}ms !important;`)
            }, we(o.name), 47, Ot))
          ]))), 256))
        ], 8, zt),
        i(t.$slots, "svg", {
          svg: { height: s.value.height, width: s.value.width }
        }, void 0, !0)
      ], 10, Ft)) : w("", !0),
      t.$slots.watermark ? (r(), v("div", Pt, [
        i(t.$slots, "watermark", M(_({ isPrinting: d(ve) || d(he) })), void 0, !0)
      ])) : w("", !0),
      ne(pt, {
        show: c.value.showTooltip && Y.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        fontSize: e.value.style.chart.tooltip.fontSize,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: C.value,
        content: te.value,
        isCustom: U.value
      }, {
        "tooltip-before": m(() => [
          i(t.$slots, "tooltip-before", M(_({ ...oe.value })), void 0, !0)
        ]),
        "tooltip-after": m(() => [
          i(t.$slots, "tooltip-after", M(_({ ...oe.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      S("div", {
        ref_key: "chartSlicer",
        ref: ce,
        style: "width:100%;background:transparent",
        "data-html2canvas-ignore": ""
      }, [
        e.value.style.chart.zoom.show && Q.value < pe.value ? (r(), A(Tt, {
          key: 0,
          value: z.value,
          "onUpdate:value": a[1] || (a[1] = (o) => z.value = o),
          min: Q.value,
          max: pe.value,
          textColor: e.value.style.chart.color,
          inputColor: e.value.style.chart.zoom.color,
          selectColor: e.value.style.chart.zoom.highlightColor,
          useResetSlot: e.value.style.chart.zoom.useResetSlot,
          background: e.value.style.chart.zoom.color,
          borderColor: e.value.style.chart.backgroundColor,
          source: e.value.style.chart.width,
          onReset: K
        }, {
          "reset-action": m(({ reset: o }) => [
            i(t.$slots, "reset-action", M(_({ reset: o })), void 0, !0)
          ]),
          _: 3
        }, 8, ["value", "min", "max", "textColor", "inputColor", "selectColor", "useResetSlot", "background", "borderColor", "source"])) : w("", !0)
      ], 512),
      t.$slots.source ? (r(), v("div", {
        key: 5,
        ref_key: "source",
        ref: T,
        dir: "auto"
      }, [
        i(t.$slots, "source", {}, void 0, !0)
      ], 512)) : w("", !0),
      F.value ? (r(), A(vt, {
        key: 6,
        hideDetails: "",
        config: {
          open: c.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: m(() => [
          (r(), A(ht, {
            key: `table_${N.value}`,
            colNames: E.value.colNames,
            head: E.value.head,
            body: E.value.body,
            config: E.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: a[2] || (a[2] = (o) => c.value.showTable = !1)
          }, {
            th: m(({ th: o }) => [
              S("div", {
                innerHTML: o,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, At)
            ]),
            td: m(({ td: o }) => [
              qe(we(o.name || o), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : w("", !0)
    ], 44, St));
  }
}, Ht = /* @__PURE__ */ Fe(Mt, [["__scopeId", "data-v-71c044b2"]]);
export {
  Ht as default
};
